import type { Partial2Levels, WidgetsConfigStore } from '@agnos-ui/svelte-headless/config';
import type { AdaptPropsSlots, SlotsPresent, Widget, WidgetFactory, WidgetProps } from '@agnos-ui/svelte-headless/types';
import type { BootstrapWidgetsConfig } from '@agnos-ui/core-bootstrap/config';
import type { ReadableSignal } from '@amadeus-it-group/tansu';
export * from '@agnos-ui/svelte-headless/config';
export type WidgetsConfig = {
    [WidgetName in keyof BootstrapWidgetsConfig]: AdaptPropsSlots<BootstrapWidgetsConfig[WidgetName]>;
};
type WidgetFactoryInput<W extends Widget> = {
    factory: WidgetFactory<W>;
    widgetName?: null | keyof WidgetsConfig;
    $$slots: SlotsPresent<WidgetProps<W>>;
    defaultConfig?: Partial<WidgetProps<W>> | ReadableSignal<Partial<WidgetProps<W>> | undefined>;
    events: Pick<WidgetProps<W>, keyof WidgetProps<W> & `on${string}Change`>;
    $$props: Partial<WidgetProps<W>>;
};
type AdaptParentConfig = (config: Partial2Levels<WidgetsConfig>) => Partial2Levels<WidgetsConfig>;
type CreateWidgetsDefaultConfig = (adaptParentConfig?: AdaptParentConfig) => WidgetsConfigStore<WidgetsConfig>;
export declare const widgetsDefaultConfigKey: symbol, createWidgetsDefaultConfig: CreateWidgetsDefaultConfig, getContextWidgetConfig: <N extends string | number | symbol>(widgetName: N) => ReadableSignal<Partial<WidgetsConfig[N]> | undefined>, callWidgetFactory: <W extends Widget>({ factory, widgetName, $$slots, defaultConfig, events, $$props, }: WidgetFactoryInput<W>) => W & {
    patchChangedProps: W['patch'];
};
